: <<see.f>> ; ( words vocabulary see 24feb02 ~ 27apr02 SamChen )
  only
  vocabulary decompiler  vocabulary disassembler
  decompiler definitions

: in-forth        only disassembler also decompiler ;
: in-decompiler   only disassembler also decompiler definitions ;
: in-disassembler only disassembler definitions also decompiler ;
  
in-forth also asm-hidden 
\ ======================================================================= \ \
  create StringDoneList 0 , \ the first reserved to append a link list    \ \
  ' doString , ' doZString ,                                              \ \
  0 , \ the last 0 used as the end-of-list                                \ \
                                                                          \ \
  create 2CellDoneList  0 , \ the first reserved to append a link list    \ \
  doOpcode , ' doWINAPI ,                                                 \ \
  0 , \ the last 0 used as end-of-list                                    \ \
                                                                          \ \
  create 1CellDoneList  0 , \ the first reserved to append a link list    \ \
  ' doUSER , ' doVAR , doCON , doVOC , doVALUE , doDEFER , doSUBR ,       \ \
  doREF , doBIND , doMACRO-REF , doMACRO-BIND , doSEG-PRE , doINST-PRE ,  \ \
  doASM-OP ,                                                              \ \
  0 , \ the last 0 used as as the end-of-list                             \ \
                                                                          \ \
  create 1CallMoreList  0 , \ the first reserved to append a link list    \ \
  ' COMPILE , ' (+to) , ' (to) , ' (is) ,                                 \ \
  0 , \ the last 0 used as end-of-list                                    \ \
                                                                          \ \
  create 1CellMoreList  0 , \ the first reserved to append a link list    \ \
  ' branch , ' ?branch , ' doNext , ' (do) , ' (?do) , ' (loop) ,         \ \
  ' (+loop) , ' (of) , ' (endof) , ' doLIT ,                              \ \
  0 , \ the last 0 used as the end-of-list                                \ \
                                                                          \ \
  create StringMoreList 0 , \ the first reserved to append a link list    \ \
  ' doabort" , ' ."| , ' $"| , ' Z"| ,                                    \ \
  0 , \ the last 0 used as the end-of-list                                \ \
                                                                          \ \
: addToList ( ca list -- ) here swap dup @ , ! , ;                        \ \
\ ======================================================================= \ \
in-decompiler

  VARIABLE branch_target  VARIABLE branch_ca  VARIABLE done
  VARIABLE code_limit     VARIABLE indent     VARIABLE next_pc
  VARIABLE code_start     VARIABLE curr_pc    VARIABLE non_branch

  0 VALUE step_depth

: .name ( ca -- ) >name .id ;
: h. ( n -- ) BASE @ >R HEX . R> BASE ! ;
: h8.r ( a -- ) BASE @ >R HEX <# # # # # # # # # #> TYPE R> BASE ! ;
: n. ( ca -- )
  dup space h8.r ( ca ) name&voc
  if ( na va ) ."  ( " cell- body> .name ."  ' " .id ."  )" exit
  then ( ca ) 0 swap ( 0 ca ) CLINK 
  BEGIN @ ( i ca la ) ?DUP
  WHILE 2DUP CELL- @ =
     IF 2 pick 0=
        IF ."  ( "
        THEN >r swap dup
        IF ."  | "
        THEN 1+ swap r> DUP CELL- BODY> name&voc
        IF cell- body> .name space .id
        ELSE h.
        THEN
     THEN 
  REPEAT DROP
  IF ."  )"
  THEN ;

: a. ( a -- a ) DUP CR ." ( " h8.r ;
: b. ( v -- )
  BASE @ >R HEX SPACE <# # # #> TYPE R>
  BASE ! ;
: m. ( a n -- a+n ) 1- 
  FOR DUP C@ b. 1+
  NEXT ;

: .end-code cr a. $10 spaces ." ) end-code" DROP cr cr ;

: cr. ."  )" a. ;

: indentspaces ( n -- ) SPACES ."  )" indent @ DUP + SPACES ;

: mm. ( a i n -- a+n ) 2DUP <
  IF OVER - >R m. cr. R> ( a' n-i ) 
     BEGIN 5 OVER <
     WHILE 5 - >R 5 m. cr. R>
     REPEAT 5 SWAP
  THEN SWAP OVER - >R m. R> 3 * indentspaces ;

: i.  ( a -- a+1 i ) a. ( a ) DUP 1+ SWAP C@ DUP b. ( a+1 i ) ;
: c@. ( a -- a+1 ) DUP 1+ SWAP C@ b. ;
: s.  ( a -- a' ) i. $3F and 1+ 4 SWAP mm. ;
: q.  ( -- ) $22 EMIT ;

: inList? ( ca list -- ca f ) swap >r dup ( list list )
  BEGIN cell+ dup @ ( list a [a] ) ?dup
  WHILE r@ =
     IF ( list a ) nip r> swap ( ca a ) exit
     THEN
  REPEAT ( list a' ) DROP ( list )
  BEGIN @ dup
  WHILE ( a" ) dup cell+ @ r@ =
     IF ( a" ) r> swap ( ca a" ) exit
     THEN
  REPEAT R> swap ( ca 0 ) ;

  cr
in-disassembler
  fload dis486pre.f \ <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
  FLOAD dis486.f    \ <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
in-decompiler
  
: 1CellMore  (  a -- a+4 ) a. 5 4 mm. dup cell- @ n. ."  , " ;
: StringMore ( a -- a+[a]+1 )
  DUP s. SWAP ."  $," q. SPACE count type q. space ;

in-forth
defer dis1
in-decompiler
: old_call. ( a -- a' )
  DUP 4 m. SWAP ( a+4 a )  @ OVER + ( a+4 ca )
  0 indentspaces DUP n. ."  call, " ( a+4 ca )

  1CellDoneList inList?
  IF ( a+4 ca ) DROP 1CellMore done ON EXIT
  THEN
  2CellDoneList inList?
  IF ( a+4 ca ) DROP 1CellMore 1CellMore done ON EXIT
  THEN
  StringDoneList inList?
  IF ( a+4 ca ) DROP StringMore done ON EXIT
  THEN

  StringMoreList inList?
  IF ( a+4 ca ) DROP StringMore EXIT
  THEN
  
  1CallMoreList inList?
  IF ( a+4 ca ) DROP a. 5 5 mm. DUP @PreRel32BitAddr n. ."  call, " EXIT
  THEN
  
  1CellMoreList inList?
  IF ( a+4 ca ) >R 1CellMore R> ( a+8 ca ) 
     DUP ['] doLIT =
     IF DROP EXIT
     THEN OVER CELL- @ branch_target ! ( a+8 ca )
     DUP ['] ?branch =
     IF DROP DUP CELL- @ code_limit @ MAX code_limit ! EXIT
     THEN 
     DUP ['] branch =
     IF non_branch OFF  DROP code_limit @ OVER <
        IF done ON EXIT
        THEN DUP CELL- @ code_limit @ MAX code_limit ! EXIT
     THEN
  THEN DROP ;
: old_dis1 ( a -- a' ) 
  branch_ca OFF  branch_target OFF  non_branch ON  i. ( a+1 i ) 

  DUP $C3 = \ see if it's the RET instruction
  IF DROP $C indentspaces ."  RET, " code_limit @ OVER < done ! EXIT
  THEN 

  DUP $E8 = \ see if it's the CALL instruction
  IF ( a+1 i ) DROP ( a+1 ) old_call. EXIT
  THEN 

  DUP $E9 = \ see if it's a 32-bit relative addr jump instruction
  IF ( a+1 i ) DROP ( a+1 ) 4 4 mm. ( a+5 ) DUP @PreRel32BitAddr
     DUP branch_target !  DUP branch_ca !  non_branch OFF
     n. ."  JMP, " 
     code_limit @ OVER <  branch_target @ @CurRelAddr ['] doNEXT = NOT AND
     IF done ON
     THEN EXIT
  THEN 
  
  DUP $EB = \ see if it's a  8-bit relative addr jump instruction
  IF ( a+1 i ) DROP ( a+1 ) 1 m. ( a+2 ) 9 indentspaces
     DUP @PreRel8BitAddr 
     DUP branch_target !  DUP branch_ca !  non_branch OFF
     n. ."  jmp, " 
     code_limit @ OVER <  branch_target @ @CurRelAddr ['] doNEXT = NOT AND
     IF done ON
     THEN EXIT
  THEN 
  
  DUP $8D =
  IF ( a+1 i ) OVER ( a+1 i a+1 ) DUP @ $5D89FC6D = 
     IF CELL+ DUP C@ $BB =
        IF ( a+1 i a+5 ) 2DROP 4 $6 mm. ( a+$7 ) ."  $LIT, "
           a. 4 m. 3 indentspaces DUP CELL- @ n. ."  , " EXIT
        THEN ( a+1 i a+5 )
        DUP @ $188B5800 = 
        SWAP CELL+ @ $5004C083 = AND
        IF ( a+1 i ) DROP 4 $10 mm. ( a+$11 ) DUP CELL- @ n. ."  $LITx, " EXIT
        THEN
     THEN OVER ( a+1 i a ) DUP @ $5D89FC6D = SWAP 3 + @ $DB33005D = AND
     IF DROP 4 7 mm. ( a+9 ) ."  $LIT0, " EXIT
     THEN
  THEN 
  
  DUP $0B =
  IF ( a+1 i ) OVER @ $005D8BDB = 
     IF OVER CELL+ @ $74046D8D =
        IF DROP ( a' ) 4 9 mm. DUP @PreRel8BitAddr ( a' ta )
           code_limit @ OVER <
           IF DUP code_limit !
           THEN DUP branch_target ! space h8.r ."  $qbran, " EXIT
        ELSE OVER CELL+ DUP @ $0F046D8D = SWAP CELL+ C@ $84 = AND
           IF DROP ( a' ) 4 $D mm. DUP @PreRel32BitAddr DUP code_limit @ OVER <
              IF code_limit !
              ELSE DROP
              THEN DUP branch_target ! space h8.r ."  $QBRAN, " EXIT
           THEN
        THEN
     THEN
  THEN 
  
  >R 4 4 mm. CELL- ."  unknown instrustion " R> b. steping @ 0 =
  IF wait
  then ;

: call. ( a -- a' )
  DUP CELL+ SWAP ( a+4 a )  @ OVER + ( a+4 ca )

  1CellDoneList inList?
  IF ( a+4 ca ) DROP 1CellMore done ON EXIT
  THEN

  2CellDoneList inList?
  IF ( a+4 ca ) DROP 1CellMore 1CellMore done ON EXIT
  THEN

  StringDoneList inList?
  IF ( a+4 ca ) DROP StringMore done ON EXIT
  THEN

  StringMoreList inList?
  IF ( a+4 ca ) DROP StringMore EXIT
  THEN
  
  1CallMoreList inList?
  IF ( a+4 ca ) DROP a. 5 5 mm. DUP @PreRel32BitAddr n. ."  call, " EXIT
  THEN
  
  1CellMoreList inList?
  IF ( a+4 ca ) >R 1CellMore R> ( a+8 ca ) 
     DUP ['] doLIT =
     IF DROP EXIT
     THEN OVER CELL- @ branch_target ! ( a+8 ca )
     DUP ['] ?branch =
     IF DROP DUP CELL- @ code_limit @ MAX code_limit ! EXIT
     THEN 
     DUP ['] branch =
     IF non_branch OFF  DROP code_limit @ OVER <
        IF done ON EXIT
        THEN DUP CELL- @ code_limit @ MAX code_limit ! EXIT
     THEN
  THEN DROP ;
  
: _dis1 ( a -- a' ) 
  branch_ca OFF  branch_target OFF  non_branch ON 
  dup inst ( a a' ) swap count ( a' a+1 i ) 

  DUP $C3 = \ see if it's the RET instruction
  IF 2DROP ( a' ) code_limit @ OVER < done ! ( a' ) EXIT
  THEN 

  DUP $E8 = \ see if it's the CALL instruction
  IF ( a' a+1 i ) DROP ( a+1 ) call. drop EXIT
  THEN 

  DUP $E9 = \ see if it's a 32-bit relative addr jump instruction
  IF ( a' a+1 i ) 2DROP ( a' ) DUP @PreRel32BitAddr ( a' ca )
     DUP branch_target !  branch_ca !  non_branch OFF
     code_limit @ OVER <  branch_target @ @CurRelAddr ['] doNEXT = NOT AND
     IF done ON
     THEN EXIT
  THEN 
  
  DUP $EB = \ see if it's a  8-bit relative addr jump instruction
  IF ( a' a+1 i ) 2DROP ( a' ) 9 indentspaces
     DUP @PreRel8BitAddr 
     DUP branch_target !  branch_ca !  non_branch OFF
     code_limit @ OVER <  branch_target @ @CurRelAddr ['] doNEXT = NOT AND
     IF done ON
     THEN EXIT
  THEN ( a' a+1 i ) 2drop ;
' old_dis1 is dis1
in-forth
: dis ( a -- )
  BEGIN dis1 ?wait done @
  UNTIL .end-code ;
also forth
: (see) ( cfa -- )  CR indent OFF  done OFF
  dup code_start !  dup code_limit !
  DUP >NAME ( cfa nfa ) ?DUP
  IF ( cfa nfa ) DUP s. DROP ."  code " DUP .ID C@ DUP $80 AND
     IF ."  IMMEDIATE "
     THEN $40 AND
     IF ."  COMPILE-only "
     THEN
  ELSE ( cfa ) ." noName "
  THEN CR dis ;

: see ( <wrd> -- ) ' (see) ;
.(   see.f Code Size:) HERE ' <<see.f>> - DECIMAL . .(  bytes) HEX  
